 
;+-------------------------------------------------------------------+
;|  Program....: Aumentando la cantidad de salidas de un 908JK1/3    |
;|  Version....: Version 1.0a                                        |
;|  Compiler...: Pemicro                                             |
;|  Author.....: Jorge M. Dhios                                      |
;|  Date.......: 02/02/2003                                          |
;|  Last Update: 02/02/2003                                          |
;|  Purpose....: Expansin de salidas en un 908JK1/3                 |
;|                                                                   |
;|  Copyright (c) 1994 Baires Robotics, All Right Reserved           |
*+-------------------------------------------------------------------+

RamStart     EQU    $0080            ; Comienzo de la RAM para el JL3
RomStart     EQU    $F600            ; Comienzo de la ROM/FLASH para el programa
VecStart     EQU    $FFDE            ; Comienzo tabla de vectores varios

$Include 'jl3regs.inc'

CLKSHT       EQU    7
DTASHT       EQU    6
STBSHT       EQU    5

             ORG    RamStart

SHIFT1       RMB    1
SHIFT2       RMB    1

             ORG    RomStart

START        RSP
             MOV    #%11100000,DDRB
             CLR    PORTB

LOOP         LDA    SHIFT2
             BSR    SHIFT

             LDA    SHIFT1
             BSR    SHIFT

             BSR    PULSE
             BRA    LOOP

* ----

SHIFT        PSHX
             LDX    #8
NEXT         LSRA
             BCS    OUT1
             BCLR   DTASHT,PORTB
             BRA    CLOCK

OUT1         BSET   DTASHT,PORTB

CLOCK        BSET   CLKSHT,PORTB
             BCLR   CLKSHT,PORTB

             DECX
             BNE    NEXT
             PULX
             RTS

* ----

PULSE        BSET   STBSHT,PORTB
             BCLR   STBSHT,PORTB 
             RTS

*----------------------------------------------------------------

             ORG    VecStart

             FDB    start              ; ADC Conversion Complete Vector
             FDB    start              ; Keyboard Vector
             FDB    0,0,0,0,0,0,0,0    ; (No Vectors Assigned $FFE2-$FFF1)
             FDB    start              ; TIM1 Overflow Vector
             FDB    start              ; TIM1 Channel 1 Vector
             FDB    start              ; TIM1 Channel 0 Vector
             FDB    start              ; (No Vector Assigned $FFF8-$FFF9)
             FDB    start              ; ~IRQ1
             FDB    start              ; SWI Vector
             FDB    start              ; Reset Vector
